import { ObjectLiteral } from 'typeorm';
import { GetDataloaderInput } from './types';
/**
 * Decorator for injecting a dataloader into a ResolveField.
 */
export declare const InjectLoader: <V extends ObjectLiteral, K = string>(...dataOrPipes: (string | Function | (new () => V) | import("typeorm").EntitySchema<V> | {
    type: V;
    name: string;
} | Pick<GetDataloaderInput<V>, "fromEntity" | "resolveType" | "fieldName" | "resolveInput" | "resultType"> | import("@nestjs/common").PipeTransform<any, any> | import("@nestjs/common").Type<import("@nestjs/common").PipeTransform<any, any>>)[]) => ParameterDecorator;
