'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var tslib = require('tslib');
var common = require('@nestjs/common');
var typeorm = require('typeorm');
var DataLoader = _interopDefault(require('dataloader'));
var graphql = require('@nestjs/graphql');

function _regeneratorRuntime() {
  /*! regenerator-runtime -- Copyright (c) 2014-present, Facebook, Inc. -- license (MIT): https://github.com/facebook/regenerator/blob/main/LICENSE */

  _regeneratorRuntime = function () {
    return exports;
  };

  var exports = {},
      Op = Object.prototype,
      hasOwn = Op.hasOwnProperty,
      $Symbol = "function" == typeof Symbol ? Symbol : {},
      iteratorSymbol = $Symbol.iterator || "@@iterator",
      asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator",
      toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag";

  function define(obj, key, value) {
    return Object.defineProperty(obj, key, {
      value: value,
      enumerable: !0,
      configurable: !0,
      writable: !0
    }), obj[key];
  }

  try {
    define({}, "");
  } catch (err) {
    define = function (obj, key, value) {
      return obj[key] = value;
    };
  }

  function wrap(innerFn, outerFn, self, tryLocsList) {
    var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator,
        generator = Object.create(protoGenerator.prototype),
        context = new Context(tryLocsList || []);
    return generator._invoke = function (innerFn, self, context) {
      var state = "suspendedStart";
      return function (method, arg) {
        if ("executing" === state) throw new Error("Generator is already running");

        if ("completed" === state) {
          if ("throw" === method) throw arg;
          return doneResult();
        }

        for (context.method = method, context.arg = arg;;) {
          var delegate = context.delegate;

          if (delegate) {
            var delegateResult = maybeInvokeDelegate(delegate, context);

            if (delegateResult) {
              if (delegateResult === ContinueSentinel) continue;
              return delegateResult;
            }
          }

          if ("next" === context.method) context.sent = context._sent = context.arg;else if ("throw" === context.method) {
            if ("suspendedStart" === state) throw state = "completed", context.arg;
            context.dispatchException(context.arg);
          } else "return" === context.method && context.abrupt("return", context.arg);
          state = "executing";
          var record = tryCatch(innerFn, self, context);

          if ("normal" === record.type) {
            if (state = context.done ? "completed" : "suspendedYield", record.arg === ContinueSentinel) continue;
            return {
              value: record.arg,
              done: context.done
            };
          }

          "throw" === record.type && (state = "completed", context.method = "throw", context.arg = record.arg);
        }
      };
    }(innerFn, self, context), generator;
  }

  function tryCatch(fn, obj, arg) {
    try {
      return {
        type: "normal",
        arg: fn.call(obj, arg)
      };
    } catch (err) {
      return {
        type: "throw",
        arg: err
      };
    }
  }

  exports.wrap = wrap;
  var ContinueSentinel = {};

  function Generator() {}

  function GeneratorFunction() {}

  function GeneratorFunctionPrototype() {}

  var IteratorPrototype = {};
  define(IteratorPrototype, iteratorSymbol, function () {
    return this;
  });
  var getProto = Object.getPrototypeOf,
      NativeIteratorPrototype = getProto && getProto(getProto(values([])));
  NativeIteratorPrototype && NativeIteratorPrototype !== Op && hasOwn.call(NativeIteratorPrototype, iteratorSymbol) && (IteratorPrototype = NativeIteratorPrototype);
  var Gp = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(IteratorPrototype);

  function defineIteratorMethods(prototype) {
    ["next", "throw", "return"].forEach(function (method) {
      define(prototype, method, function (arg) {
        return this._invoke(method, arg);
      });
    });
  }

  function AsyncIterator(generator, PromiseImpl) {
    function invoke(method, arg, resolve, reject) {
      var record = tryCatch(generator[method], generator, arg);

      if ("throw" !== record.type) {
        var result = record.arg,
            value = result.value;
        return value && "object" == typeof value && hasOwn.call(value, "__await") ? PromiseImpl.resolve(value.__await).then(function (value) {
          invoke("next", value, resolve, reject);
        }, function (err) {
          invoke("throw", err, resolve, reject);
        }) : PromiseImpl.resolve(value).then(function (unwrapped) {
          result.value = unwrapped, resolve(result);
        }, function (error) {
          return invoke("throw", error, resolve, reject);
        });
      }

      reject(record.arg);
    }

    var previousPromise;

    this._invoke = function (method, arg) {
      function callInvokeWithMethodAndArg() {
        return new PromiseImpl(function (resolve, reject) {
          invoke(method, arg, resolve, reject);
        });
      }

      return previousPromise = previousPromise ? previousPromise.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg();
    };
  }

  function maybeInvokeDelegate(delegate, context) {
    var method = delegate.iterator[context.method];

    if (undefined === method) {
      if (context.delegate = null, "throw" === context.method) {
        if (delegate.iterator.return && (context.method = "return", context.arg = undefined, maybeInvokeDelegate(delegate, context), "throw" === context.method)) return ContinueSentinel;
        context.method = "throw", context.arg = new TypeError("The iterator does not provide a 'throw' method");
      }

      return ContinueSentinel;
    }

    var record = tryCatch(method, delegate.iterator, context.arg);
    if ("throw" === record.type) return context.method = "throw", context.arg = record.arg, context.delegate = null, ContinueSentinel;
    var info = record.arg;
    return info ? info.done ? (context[delegate.resultName] = info.value, context.next = delegate.nextLoc, "return" !== context.method && (context.method = "next", context.arg = undefined), context.delegate = null, ContinueSentinel) : info : (context.method = "throw", context.arg = new TypeError("iterator result is not an object"), context.delegate = null, ContinueSentinel);
  }

  function pushTryEntry(locs) {
    var entry = {
      tryLoc: locs[0]
    };
    1 in locs && (entry.catchLoc = locs[1]), 2 in locs && (entry.finallyLoc = locs[2], entry.afterLoc = locs[3]), this.tryEntries.push(entry);
  }

  function resetTryEntry(entry) {
    var record = entry.completion || {};
    record.type = "normal", delete record.arg, entry.completion = record;
  }

  function Context(tryLocsList) {
    this.tryEntries = [{
      tryLoc: "root"
    }], tryLocsList.forEach(pushTryEntry, this), this.reset(!0);
  }

  function values(iterable) {
    if (iterable) {
      var iteratorMethod = iterable[iteratorSymbol];
      if (iteratorMethod) return iteratorMethod.call(iterable);
      if ("function" == typeof iterable.next) return iterable;

      if (!isNaN(iterable.length)) {
        var i = -1,
            next = function next() {
          for (; ++i < iterable.length;) if (hasOwn.call(iterable, i)) return next.value = iterable[i], next.done = !1, next;

          return next.value = undefined, next.done = !0, next;
        };

        return next.next = next;
      }
    }

    return {
      next: doneResult
    };
  }

  function doneResult() {
    return {
      value: undefined,
      done: !0
    };
  }

  return GeneratorFunction.prototype = GeneratorFunctionPrototype, define(Gp, "constructor", GeneratorFunctionPrototype), define(GeneratorFunctionPrototype, "constructor", GeneratorFunction), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, toStringTagSymbol, "GeneratorFunction"), exports.isGeneratorFunction = function (genFun) {
    var ctor = "function" == typeof genFun && genFun.constructor;
    return !!ctor && (ctor === GeneratorFunction || "GeneratorFunction" === (ctor.displayName || ctor.name));
  }, exports.mark = function (genFun) {
    return Object.setPrototypeOf ? Object.setPrototypeOf(genFun, GeneratorFunctionPrototype) : (genFun.__proto__ = GeneratorFunctionPrototype, define(genFun, toStringTagSymbol, "GeneratorFunction")), genFun.prototype = Object.create(Gp), genFun;
  }, exports.awrap = function (arg) {
    return {
      __await: arg
    };
  }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, asyncIteratorSymbol, function () {
    return this;
  }), exports.AsyncIterator = AsyncIterator, exports.async = function (innerFn, outerFn, self, tryLocsList, PromiseImpl) {
    void 0 === PromiseImpl && (PromiseImpl = Promise);
    var iter = new AsyncIterator(wrap(innerFn, outerFn, self, tryLocsList), PromiseImpl);
    return exports.isGeneratorFunction(outerFn) ? iter : iter.next().then(function (result) {
      return result.done ? result.value : iter.next();
    });
  }, defineIteratorMethods(Gp), define(Gp, toStringTagSymbol, "Generator"), define(Gp, iteratorSymbol, function () {
    return this;
  }), define(Gp, "toString", function () {
    return "[object Generator]";
  }), exports.keys = function (object) {
    var keys = [];

    for (var key in object) keys.push(key);

    return keys.reverse(), function next() {
      for (; keys.length;) {
        var key = keys.pop();
        if (key in object) return next.value = key, next.done = !1, next;
      }

      return next.done = !0, next;
    };
  }, exports.values = values, Context.prototype = {
    constructor: Context,
    reset: function (skipTempReset) {
      if (this.prev = 0, this.next = 0, this.sent = this._sent = undefined, this.done = !1, this.delegate = null, this.method = "next", this.arg = undefined, this.tryEntries.forEach(resetTryEntry), !skipTempReset) for (var name in this) "t" === name.charAt(0) && hasOwn.call(this, name) && !isNaN(+name.slice(1)) && (this[name] = undefined);
    },
    stop: function () {
      this.done = !0;
      var rootRecord = this.tryEntries[0].completion;
      if ("throw" === rootRecord.type) throw rootRecord.arg;
      return this.rval;
    },
    dispatchException: function (exception) {
      if (this.done) throw exception;
      var context = this;

      function handle(loc, caught) {
        return record.type = "throw", record.arg = exception, context.next = loc, caught && (context.method = "next", context.arg = undefined), !!caught;
      }

      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i],
            record = entry.completion;
        if ("root" === entry.tryLoc) return handle("end");

        if (entry.tryLoc <= this.prev) {
          var hasCatch = hasOwn.call(entry, "catchLoc"),
              hasFinally = hasOwn.call(entry, "finallyLoc");

          if (hasCatch && hasFinally) {
            if (this.prev < entry.catchLoc) return handle(entry.catchLoc, !0);
            if (this.prev < entry.finallyLoc) return handle(entry.finallyLoc);
          } else if (hasCatch) {
            if (this.prev < entry.catchLoc) return handle(entry.catchLoc, !0);
          } else {
            if (!hasFinally) throw new Error("try statement without catch or finally");
            if (this.prev < entry.finallyLoc) return handle(entry.finallyLoc);
          }
        }
      }
    },
    abrupt: function (type, arg) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];

        if (entry.tryLoc <= this.prev && hasOwn.call(entry, "finallyLoc") && this.prev < entry.finallyLoc) {
          var finallyEntry = entry;
          break;
        }
      }

      finallyEntry && ("break" === type || "continue" === type) && finallyEntry.tryLoc <= arg && arg <= finallyEntry.finallyLoc && (finallyEntry = null);
      var record = finallyEntry ? finallyEntry.completion : {};
      return record.type = type, record.arg = arg, finallyEntry ? (this.method = "next", this.next = finallyEntry.finallyLoc, ContinueSentinel) : this.complete(record);
    },
    complete: function (record, afterLoc) {
      if ("throw" === record.type) throw record.arg;
      return "break" === record.type || "continue" === record.type ? this.next = record.arg : "return" === record.type ? (this.rval = this.arg = record.arg, this.method = "return", this.next = "end") : "normal" === record.type && afterLoc && (this.next = afterLoc), ContinueSentinel;
    },
    finish: function (finallyLoc) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.finallyLoc === finallyLoc) return this.complete(entry.completion, entry.afterLoc), resetTryEntry(entry), ContinueSentinel;
      }
    },
    catch: function (tryLoc) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];

        if (entry.tryLoc === tryLoc) {
          var record = entry.completion;

          if ("throw" === record.type) {
            var thrown = record.arg;
            resetTryEntry(entry);
          }

          return thrown;
        }
      }

      throw new Error("illegal catch attempt");
    },
    delegateYield: function (iterable, resultName, nextLoc) {
      return this.delegate = {
        iterator: values(iterable),
        resultName: resultName,
        nextLoc: nextLoc
      }, "next" === this.method && (this.arg = undefined), ContinueSentinel;
    }
  }, exports;
}

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
  try {
    var info = gen[key](arg);
    var value = info.value;
  } catch (error) {
    reject(error);
    return;
  }

  if (info.done) {
    resolve(value);
  } else {
    Promise.resolve(value).then(_next, _throw);
  }
}

function _asyncToGenerator(fn) {
  return function () {
    var self = this,
        args = arguments;
    return new Promise(function (resolve, reject) {
      var gen = fn.apply(self, args);

      function _next(value) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
      }

      function _throw(err) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
      }

      _next(undefined);
    });
  };
}

function _extends() {
  _extends = Object.assign ? Object.assign.bind() : function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };
  return _extends.apply(this, arguments);
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

  return arr2;
}

function _createForOfIteratorHelperLoose(o, allowArrayLike) {
  var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"];
  if (it) return (it = it.call(o)).next.bind(it);

  if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") {
    if (it) o = it;
    var i = 0;
    return function () {
      if (i >= o.length) return {
        done: true
      };
      return {
        done: false,
        value: o[i++]
      };
    };
  }

  throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

/**
 * Wrapper class for Dataloader.
 */

exports.BaseDataLoader = /*#__PURE__*/function () {
  function BaseDataLoader(inp) {
    // getRepository has been changed to dataSource.getRepository for TypeORM versions above 3.0
    this.valueRepo = dataSource.getRepository(inp.fromEntity);
    this.type = inp.resolveType || 'one';
    this.resolveInput = inp.resolveInput;
    this.fieldName = inp.fieldName || 'id';
    this.resultType = inp.resultType || 'entity'; //TODO: use strict types

    this.dataloader = this.type === 'one' ? new DataLoader(this.getBatchLoadFunction()) : this.resultType === 'count' ? new DataLoader(this.getBatchLoadFunction()) : new DataLoader(this.getBatchLoadFunction());

    if (this.type === 'many-to-many' && this.resultType !== 'count') {
      var _this$resolveInput$re;

      if (!this.resolveInput) {
        this.resolveInput = {
          relations: [this.fieldName]
        };
      } else if (typeof this.resolveInput === 'object' && !((_this$resolveInput$re = this.resolveInput.relations) != null && _this$resolveInput$re.includes(this.fieldName))) {
        var _this$resolveInput$re2;

        this.resolveInput = _extends({}, this.resolveInput, {
          relations: [].concat((_this$resolveInput$re2 = this.resolveInput.relations) != null ? _this$resolveInput$re2 : [], [this.fieldName])
        });
      }
    }
  }

  var _proto = BaseDataLoader.prototype;

  _proto.getBatchLoadFunction = function getBatchLoadFunction() {
    var _this = this;

    return /*#__PURE__*/function () {
      var _ref = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee(keys) {
        var isCountType, values, result, map, _map, pushToMap;

        return _regeneratorRuntime().wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                isCountType = _this.resultType === 'count';
                _context.next = 3;
                return _this.getValuesFromKeys(keys, isCountType);

              case 3:
                values = _context.sent;

                if (!isCountType) {
                  _context.next = 6;
                  break;
                }

                return _context.abrupt("return", keys.map(function (key) {
                  var _ref2, _ref3;

                  var value = values.find(function (value) {
                    return value.key === key;
                  });
                  return value ? (_ref2 = {}, _ref2[key] = value.count, _ref2) : (_ref3 = {}, _ref3[key] = 0, _ref3);
                }));

              case 6:
                if (!(_this.type === 'one')) {
                  _context.next = 13;
                  break;
                }

                map = new Map();
                values.forEach(function (value) {
                  //TODO: use strict types
                  map.set(value[_this.fieldName], value);
                });
                result = keys.map(function (key) {
                  //TODO: is this the optimal way for type safety?
                  return map.get(key) || {};
                });
                return _context.abrupt("return", result);

              case 13:
                _map = new Map();

                pushToMap = function pushToMap(key, value) {
                  var valArr = _map.get(key);

                  valArr == null ? void 0 : valArr.push(value);

                  _map.set(key, valArr);
                };

                values.forEach(function (value) {
                  var fieldName;

                  if (_this.type === 'many') {
                    fieldName = value[_this.fieldName]; //TODO: use strict types

                    if (!_map.has(fieldName)) {
                      _map.set(value[_this.fieldName], [value]);

                      return;
                    }

                    pushToMap(fieldName, value);
                  } else if (_this.type === 'many-to-many') {
                    for (var _iterator = _createForOfIteratorHelperLoose(value[_this.fieldName]), _step; !(_step = _iterator()).done;) {
                      var entry = _step.value;
                      fieldName = entry.id;

                      if (!_map.has(fieldName)) {
                        _map.set(fieldName, [value]);
                      } else {
                        pushToMap(fieldName, value);
                      }
                    }
                  }
                });
                result = keys.map(function (key) {
                  return _map.get(key) || [];
                });
                return _context.abrupt("return", result);

              case 18:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      return function (_x) {
        return _ref.apply(this, arguments);
      };
    }();
  };

  _proto.getValuesFromKeys = /*#__PURE__*/function () {
    var _getValuesFromKeys = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee2(keys, isCountType) {
      var _where;

      var findQueryObj, values, where;
      return _regeneratorRuntime().wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              findQueryObj = {
                where: (_where = {}, _where[this.fieldName] = this.type === 'many-to-many' ? {
                  id: typeorm.In(keys)
                } : typeorm.In(keys), _where)
              };
              values = []; // CASE: When result type is count

              if (!(typeof this.resolveInput === 'function')) {
                _context2.next = 8;
                break;
              }

              _context2.next = 5;
              return this.resolveInput(keys);

            case 5:
              values = _context2.sent;
              _context2.next = 29;
              break;

            case 8:
              if (!isCountType) {
                _context2.next = 18;
                break;
              }

              if (this.resolveInput) {
                _context2.next = 15;
                break;
              }

              _context2.next = 12;
              return this.getFieldCountObject(keys);

            case 12:
              values = _context2.sent;
              _context2.next = 16;
              break;

            case 15:
              throw new common.HttpException('resolveInput cannot be added when the resultType is set to count', common.HttpStatus.BAD_REQUEST);

            case 16:
              _context2.next = 29;
              break;

            case 18:
              if (this.resolveInput) {
                _context2.next = 24;
                break;
              }

              _context2.next = 21;
              return this.valueRepo.find(findQueryObj);

            case 21:
              values = _context2.sent;
              _context2.next = 29;
              break;

            case 24:
              //CASE: Find query object received. Using in conjunction with fieldName
              where = [_extends({}, this.resolveInput.where, findQueryObj.where)];
              findQueryObj = _extends({}, this.resolveInput, {
                where: where
              });
              _context2.next = 28;
              return this.valueRepo.find(findQueryObj);

            case 28:
              values = _context2.sent;

            case 29:
              return _context2.abrupt("return", values);

            case 30:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2, this);
    }));

    function getValuesFromKeys(_x2, _x3) {
      return _getValuesFromKeys.apply(this, arguments);
    }

    return getValuesFromKeys;
  }();

  _proto.getFieldCountObject = /*#__PURE__*/function () {
    var _getFieldCountObject = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee3(keys) {
      var _this$valueRepo$metad;

      var isMany, entityName, joinTableName, tableName, fieldName, query;
      return _regeneratorRuntime().wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              isMany = this.type === 'many-to-many';
              entityName = this.valueRepo.metadata.targetName;
              joinTableName = (_this$valueRepo$metad = this.valueRepo.metadata.findRelationWithPropertyPath(this.fieldName)) == null ? void 0 : _this$valueRepo$metad.inverseEntityMetadata.targetName;
              tableName = isMany ? joinTableName : entityName;
              fieldName = isMany ? 'id' : this.fieldName;
              query = this.valueRepo.createQueryBuilder().select([tableName + "." + fieldName + " as key"]).addSelect("COALESCE(COUNT(*), 0) as count").where(tableName + "." + fieldName + " IN (:...keys)", {
                keys: keys
              }).groupBy(tableName + "." + fieldName);

              if (!(this.type === 'many-to-many')) {
                _context3.next = 10;
                break;
              }

              _context3.next = 9;
              return query.leftJoin(entityName + "." + this.fieldName, "" + joinTableName).getRawMany();

            case 9:
              return _context3.abrupt("return", _context3.sent);

            case 10:
              _context3.next = 12;
              return query.getRawMany();

            case 12:
              return _context3.abrupt("return", _context3.sent);

            case 13:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3, this);
    }));

    function getFieldCountObject(_x4) {
      return _getFieldCountObject.apply(this, arguments);
    }

    return getFieldCountObject;
  }();

  _proto.getDataLoader = function getDataLoader() {
    return this.dataloader;
  };

  return BaseDataLoader;
}();

exports.BaseDataLoader = /*#__PURE__*/tslib.__decorate([/*#__PURE__*/common.Injectable({
  scope: common.Scope.REQUEST
}), /*#__PURE__*/tslib.__metadata("design:paramtypes", [Object])], exports.BaseDataLoader);

function isObjectInput(obj) {
  return obj.fromEntity !== undefined;
}
function validateInjectLoaderInput(input, dataloaderName) {
  if (!input) throw new Error("Invalid input recieved for @InjectLoader decorator at ResolveField:" + dataloaderName);
} // function to initialize the dataSource and assign a value to the global variable

var addDataSource = function addDataSource(dataSource) {
  dataSource.initialize();
  globalThis.dataSource = dataSource;
};

var BASE_DATALOADERS = 'BASE_DATALOADERS';
/**
 * Decorator for injecting a dataloader into a ResolveField.
 */

var InjectLoader = /*#__PURE__*/common.createParamDecorator( /*#__PURE__*/function () {
  var _ref = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee(input, context) {
    var dataloaderName, baseDataLoaderInput;
    return _regeneratorRuntime().wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            //TODO: Improve type checking for input
            //Using resolveField's name as the dataloader name
            dataloaderName = context.getClass().name + "." + context.getHandler().name;
            validateInjectLoaderInput(input, dataloaderName);

            if (isObjectInput(input)) {
              baseDataLoaderInput = _extends({
                dataloaderName: dataloaderName
              }, input);
            } else {
              //CASE: input is an EntityTarget
              baseDataLoaderInput = {
                dataloaderName: dataloaderName,
                resolveType: 'one',
                fromEntity: input,
                fieldName: 'id',
                resultType: 'entity'
              };
            }

            return _context.abrupt("return", getDataLoaderFromContext(baseDataLoaderInput, context));

          case 4:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));

  return function (_x, _x2) {
    return _ref.apply(this, arguments);
  };
}());
/**
 * Creates a new BaseDataLoader for the required Dataloader if one doesn't exist in the context,
 * otherwise returns the existing BaseDataLoader.
 * @param inp Input object for getting the dataloader
 * @param inputContext Execution context
 * @returns DataLoader object
 */

function getDataLoaderFromContext(_x3, _x4) {
  return _getDataLoaderFromContext.apply(this, arguments);
}

function _getDataLoaderFromContext() {
  _getDataLoaderFromContext = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee2(inp, inputContext) {
    var context, dataloader;
    return _regeneratorRuntime().wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            context = graphql.GqlExecutionContext.create(inputContext).getContext();

            if (context[BASE_DATALOADERS] === undefined) {
              context[BASE_DATALOADERS] = {};
            }

            if (context[BASE_DATALOADERS][inp.dataloaderName] === undefined) {
              context[BASE_DATALOADERS][inp.dataloaderName] = new exports.BaseDataLoader(inp);
            }

            _context2.next = 5;
            return context[BASE_DATALOADERS][inp.dataloaderName].getDataLoader();

          case 5:
            dataloader = _context2.sent;
            return _context2.abrupt("return", dataloader);

          case 7:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));
  return _getDataLoaderFromContext.apply(this, arguments);
}

exports.InjectLoader = InjectLoader;
exports.addDataSource = addDataSource;
exports.isObjectInput = isObjectInput;
exports.validateInjectLoaderInput = validateInjectLoaderInput;
//# sourceMappingURL=nestjs-dataloader.cjs.development.js.map
