import { FindManyOptions, ObjectLiteral, EntityTarget } from 'typeorm';
export declare type ResolveType = 'one' | 'many' | 'many-to-many';
export declare type ResultType = 'entity' | 'count';
export declare type ResolveInput<Entity> = Function | FindManyOptions<Entity> | ObjectLiteral;
export declare type InjectLoaderInput<V> = EntityTarget<V> | ObjectInput<V>;
export declare type ObjectInput<V> = Omit<GetDataloaderInput<V>, 'dataloaderName'>;
export interface GetDataloaderInput<Entity> {
    dataloaderName: string;
    fromEntity: EntityTarget<Entity>;
    resolveType?: ResolveType;
    fieldName?: string;
    resolveInput?: ResolveInput<Entity>;
    resultType?: ResultType;
}
