import { DataSource } from 'typeorm';
import { InjectLoaderInput, ObjectInput } from './types';
declare global {
    var dataSource: DataSource;
}
export declare function isObjectInput<V>(obj: InjectLoaderInput<V>): obj is ObjectInput<V>;
export declare function validateInjectLoaderInput<V>(input: InjectLoaderInput<V>, dataloaderName: string): void;
export declare const addDataSource: (dataSource: DataSource) => void;
